Index: main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/MergeMetadataForSharedProgramHelper.java
===================================================================
--- main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/MergeMetadataForSharedProgramHelper.java	(revision 0)
+++ main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/MergeMetadataForSharedProgramHelper.java	(revision 0)
@@ -0,0 +1,1276 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.odfsync.cdmfr;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+import javax.jcr.Node;
+import javax.jcr.NodeIterator;
+import javax.jcr.Property;
+import javax.jcr.PropertyIterator;
+import javax.jcr.RepositoryException;
+import javax.jcr.Session;
+import javax.jcr.Value;
+import javax.jcr.ValueFactory;
+
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.logger.Logger;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
+import org.apache.commons.lang.ArrayUtils;
+import org.apache.commons.lang.StringUtils;
+import org.apache.excalibur.xml.xpath.XPathProcessor;
+import org.w3c.dom.Document;
+import org.w3c.dom.NodeList;
+
+import org.ametys.cms.contenttype.ContentType;
+import org.ametys.cms.contenttype.ContentTypeExtensionPoint;
+import org.ametys.cms.contenttype.MetadataDefinition;
+import org.ametys.cms.contenttype.MetadataType;
+import org.ametys.cms.contenttype.RepeaterDefinition;
+import org.ametys.odf.SynchronizableContent;
+import org.ametys.odf.orgunit.OrgUnit;
+import org.ametys.odf.person.Person;
+import org.ametys.odf.program.Program;
+import org.ametys.odf.program.SubProgram;
+import org.ametys.odf.program.SubProgramFactory;
+import org.ametys.plugins.odfsync.SynchronizationReport;
+import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.plugins.repository.RepositoryConstants;
+import org.ametys.plugins.repository.metadata.CompositeMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableCompositeMetadata;
+
+/**
+ * Helper for merging metadata from shared programs
+ */
+public class MergeMetadataForSharedProgramHelper implements Serviceable, Component
+{
+    /** The avalon role */
+    public static final String ROLE = MergeMetadataForSharedProgramHelper.class.getName();
+
+    /** The name of the shared programs */
+    public static final String SHARED_PROGRAMS_JCR_NODE = "shared-programs";
+
+    /** The content type extension point */
+    protected ContentTypeExtensionPoint _cTypeE;
+    
+    /** The xpath processor */
+    protected XPathProcessor _xPathProcessor;
+    
+    /** The ametys object resolver */
+    protected AmetysObjectResolver _resolver;
+    
+    /** The ametys object resolver */
+    protected CDMFrImportManager _importManager;
+    
+    @Override
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        _cTypeE = (ContentTypeExtensionPoint) manager.lookup(ContentTypeExtensionPoint.ROLE);        
+        _xPathProcessor = (XPathProcessor) manager.lookup(XPathProcessor.ROLE);
+        _resolver = (AmetysObjectResolver) manager.lookup(AmetysObjectResolver.ROLE);
+    }
+    
+    /**
+     * Initialize the component with the import manager
+     * @param importManager the import manager
+     */
+    public void initialize(CDMFrImportManager importManager)
+    {
+        _importManager = importManager;
+    }
+    
+    /**
+     * Synchronize the main program with shared metadata
+     * @param mainProgram the main program
+     * @param metadataToMerge the metadata to merge
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some changes
+     * @throws RepositoryException if an error occurred
+     */
+    public boolean synchronizeMainProgram(SubProgram mainProgram, Set<String> metadataToMerge, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (!_checkMetadataPath(metadataToMerge, report, logger))
+        {
+            return false;
+        }
+        
+        boolean hasChanged = false;
+        for (String metadataPath : metadataToMerge)
+        {
+            ContentType cType = _cTypeE.getExtension(SubProgramFactory.SUBPROGRAM_CONTENT_TYPE);
+            String[] pathSegments = StringUtils.split(metadataPath, '/');
+            MetadataDefinition metadataDefinition = cType.getMetadataDefinition(pathSegments[0]);
+            if (metadataDefinition.isMultiple())
+            {
+                hasChanged = synchronizeMultipleMetadataForMainProgram(metadataDefinition, mainProgram, metadataPath, report, logger) || hasChanged;
+            }
+            else
+            {
+                hasChanged = synchronizeSingleMetadataForMainProgram(metadataDefinition, mainProgram, metadataPath, report, logger) || hasChanged;
+            }
+        }
+        
+        if (hasChanged)
+        {
+            mainProgram.saveChanges();
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize multiple metadata for main program
+     * @param metadataDefinition the metadata definition
+     * @param mainProgram the main program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some changes
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMultipleMetadataForMainProgram(MetadataDefinition metadataDefinition, SubProgram mainProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        MetadataType type = metadataDefinition.getType();
+        List<Value> metadataValues = getMetadataListValues(mainProgram, metadataPath, report, logger);
+        switch (type)
+        {
+            case STRING:
+            case REFERENCE:
+            case USER:
+                Set<String> allStringValue = new HashSet<String>();
+                String[] stringArray = mainProgram.getStringArray(metadataPath);
+                allStringValue.addAll(Arrays.asList(stringArray));
+                
+                for (Value stringValue : metadataValues)
+                {
+                    allStringValue.add(stringValue.getString());
+                }
+                
+                if (mainProgram.getMetadataHolder().getBoolean(metadataPath  + SynchronizableContent.SYNC_SUFFIX, false))
+                {
+                    mainProgram.setRemoteMetadata(metadataPath, allStringValue.toArray(new String[allStringValue.size()]));
+                }
+                else
+                {
+                    mainProgram.getMetadataHolder().setMetadata(metadataPath, allStringValue.toArray(new String[allStringValue.size()]));
+                }
+                return true;
+            case DOUBLE:
+                double[] doubleArray = mainProgram.getDoubleArray(metadataPath);
+                Set<Double> allDoubleArray = new HashSet<Double>();
+                allDoubleArray.addAll(Arrays.asList(Arrays.asList(doubleArray).toArray(new Double[doubleArray.length])));
+                
+                for (Value stringValue : metadataValues)
+                {
+                    allDoubleArray.add(stringValue.getDouble());
+                }
+                
+                if (mainProgram.getMetadataHolder().getBoolean(metadataPath  + SynchronizableContent.SYNC_SUFFIX, false))
+                {
+                    mainProgram.setRemoteMetadata(metadataPath, allDoubleArray.toArray(new String[allDoubleArray.size()]));
+                }
+                else
+                {
+                    mainProgram.getMetadataHolder().setMetadata(metadataPath, allDoubleArray.toArray(new String[allDoubleArray.size()]));
+                }
+                return true;
+            case LONG:
+                long[] longArray = mainProgram.getLongArray(metadataPath);
+                Set<Long> allLongArray = new HashSet<Long>();
+                allLongArray.addAll(Arrays.asList(Arrays.asList(longArray).toArray(new Long[longArray.length])));
+                
+                for (Value stringValue : metadataValues)
+                {
+                    allLongArray.add(stringValue.getLong());
+                }
+                
+                if (mainProgram.getMetadataHolder().getBoolean(metadataPath  + SynchronizableContent.SYNC_SUFFIX, false))
+                {
+                    mainProgram.setRemoteMetadata(metadataPath, allLongArray.toArray(new String[allLongArray.size()]));
+                }
+                else
+                {
+                    mainProgram.getMetadataHolder().setMetadata(metadataPath, allLongArray.toArray(new String[allLongArray.size()]));
+                }
+                return true;
+            default:
+                String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                return false;
+        }
+    }
+    
+    /**
+     * Synchronize single metadata for main program
+     * @param metadataDefinition the metadata definition
+     * @param mainProgram the main program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some changes
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeSingleMetadataForMainProgram(MetadataDefinition metadataDefinition, SubProgram mainProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        MetadataType type = metadataDefinition.getType();
+        switch (type)
+        {
+            case COMPOSITE:
+                if (metadataDefinition instanceof RepeaterDefinition)
+                {
+                    return synchronizeMainProgramRepeater(metadataDefinition, mainProgram, metadataPath, report, logger);
+                }
+                else
+                {    
+                    String warnMessage = "La fusion des métadonnées n'est pas gérée pour les valeurs simple";
+                    report.warn(warnMessage);
+                    logger.warn(warnMessage);
+                }
+                return false;
+            default:
+                String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                return false;
+        }
+    }
+    
+    /**
+     * Get the metadata list values from shared program
+     * @param mainProgram the main program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return the list of the metadata values
+     * @throws RepositoryException if an error occurred
+     */
+    protected List<Value> getMetadataListValues(SubProgram mainProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        String[] sharedProgramList = mainProgram.getSharedWith();
+        Node mainProgramNode = mainProgram.getNode();
+        List<Value> metadataValues = new ArrayList<Value>();
+        if (mainProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE))
+        {
+            Node sharedProgramsNode = mainProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE);
+            for (String programCode : sharedProgramList)
+            {
+                if (sharedProgramsNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + programCode))
+                {
+                    Node sharedProgramNode = sharedProgramsNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + programCode);
+                    Property property = sharedProgramNode.getProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath);
+                    metadataValues.addAll(Arrays.asList(property.getValues()));
+                }
+            }
+        }
+        
+        return metadataValues;
+    }
+    
+    /**
+     * Get the list of repeater entry from shared program
+     * @param mainProgram the main program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return the list of the repeater entry node
+     * @throws RepositoryException if an error occurred
+     */
+    protected List<Node> getMetadataRepeaterListNodes(SubProgram mainProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        List<Node> repeaterEntryNodeList = new ArrayList<Node>();
+        
+        String[] sharedProgramList = mainProgram.getSharedWith();
+        Node mainProgramNode = mainProgram.getNode();
+        if (mainProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE))
+        {
+            Node sharedProgramsNode = mainProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE);
+            for (String programCode : sharedProgramList)
+            {
+                if (sharedProgramsNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + programCode))
+                {
+                    Node sharedProgramNode = sharedProgramsNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + programCode);
+                    if (sharedProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath))
+                    {
+                        Node repeaterNode = sharedProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath);
+                        NodeIterator entryNodes = repeaterNode.getNodes();
+                        while (entryNodes.hasNext())
+                        {
+                            repeaterEntryNodeList.add((Node) entryNodes.next());
+                        }
+                    }
+                }
+            }
+        }
+        
+        return repeaterEntryNodeList;
+    }
+    
+    /**
+     * Merge all repeater entry to the main program
+     * @param metadataDefinition the metadata definition
+     * @param mainProgram the main program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some changes
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMainProgramRepeater(MetadataDefinition metadataDefinition, SubProgram mainProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        List<Node> repeaterEntryNodeList = getMetadataRepeaterListNodes(mainProgram, metadataPath, report, logger);
+        
+        Node mainProgramNode = mainProgram.getNode();
+        if (mainProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath))
+        {
+            mainProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath).remove();
+        }
+        
+        mainProgramNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, "ametys:compositeMetadata");
+        
+        int nbEntry = 1;
+        Node repeaterNode = mainProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath);
+        for (Node entryNode : repeaterEntryNodeList)
+        {
+            Node repeaterEntryNode = repeaterNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + nbEntry, "ametys:compositeMetadata");
+            nbEntry++;
+            
+            PropertyIterator properties = entryNode.getProperties();
+            while (properties.hasNext())
+            {
+                Property property = (Property) properties.next();
+                if (property.getName().startsWith(RepositoryConstants.NAMESPACE_PREFIX + ":"))
+                {
+                    MetadataDefinition metadataRepeaterEntryDefinition = metadataDefinition.getMetadataDefinition(StringUtils.substringAfter(property.getName(), RepositoryConstants.NAMESPACE_PREFIX + ":"));
+                    if (metadataRepeaterEntryDefinition.isMultiple())
+                    {
+                        repeaterEntryNode.setProperty(property.getName(), property.getValues());
+                        hasChanged = true;
+                    }
+                    else
+                    {
+                        repeaterEntryNode.setProperty(property.getName(), property.getValue());
+                        hasChanged = true;
+                    }
+                }
+            }
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize the shared program node for main program
+     * @param mainProgram the main program
+     * @param sharedProgram the shared program
+     * @param metadataToMerge the set of metadata to merge
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    public boolean synchronizeSharedProgramNode(SubProgram mainProgram, SubProgram sharedProgram, Set<String> metadataToMerge, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (!_checkMetadataPath(metadataToMerge, report, logger))
+        {
+            return false;
+        }
+        
+        boolean hasChanged = false;
+        String sharedProgramCode = sharedProgram.getCode();
+        Node sharedProgramNode = getSharedProgramNode(mainProgram, sharedProgramCode, report, logger);
+        
+        hasChanged = synchronizeAllMetadataForSharedProgram(sharedProgramNode, sharedProgram, metadataToMerge, report, logger);
+        
+        if (hasChanged)
+        {
+            mainProgram.getNode().getSession().save();
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize the shared program node for main program
+     * @param doc the document
+     * @param mainProgram the main program node
+     * @param sharedProgramDom the dom of the shared program
+     * @param metadataToMerge the set of metadata to merge
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    public boolean synchronizeSharedProgramNode(Document doc, SubProgram mainProgram, org.w3c.dom.Node sharedProgramDom, Set<String> metadataToMerge, String lang, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (!_checkMetadataPath(metadataToMerge, report, logger))
+        {
+            return false;
+        }
+        
+        boolean hasChanged = false;
+        String sharedProgramCode = _xPathProcessor.evaluateAsString(sharedProgramDom, Program.CODE);
+        Node sharedProgramNode = getSharedProgramNode(mainProgram, sharedProgramCode, report, logger);
+        
+        hasChanged = synchronizeAllMetadataForSharedProgram(doc, sharedProgramNode, sharedProgramDom, metadataToMerge, lang, report, logger);
+        
+        if (hasChanged)
+        {
+            mainProgram.getNode().getSession().save();
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize all the metadata 
+     * @param sharedProgramNode the shared program node
+     * @param sharedProgram the shared program
+     * @param metadataToMerge the metadata to merge
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeAllMetadataForSharedProgram(Node sharedProgramNode, SubProgram sharedProgram, Set<String> metadataToMerge, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        for (String metadataPath : metadataToMerge)
+        {
+            ContentType cType = _cTypeE.getExtension(SubProgramFactory.SUBPROGRAM_CONTENT_TYPE);
+            String[] pathSegments = StringUtils.split(metadataPath, '/');
+            MetadataDefinition metadataDefinition = cType.getMetadataDefinition(pathSegments[0]);
+            
+            hasChanged = synchronizeMetadataForSharedProgram(metadataDefinition, sharedProgramNode, sharedProgram, metadataPath, report, logger) || hasChanged;
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize all the metadata 
+     * @param doc the document
+     * @param sharedProgramNode the shared program node
+     * @param sharedProgramDom the dom of the shared program
+     * @param metadataToMerge the metadata to merge
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeAllMetadataForSharedProgram(Document doc, Node sharedProgramNode, org.w3c.dom.Node sharedProgramDom, Set<String> metadataToMerge, String lang, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        for (String metadataPath : metadataToMerge)
+        {
+            ContentType cType = _cTypeE.getExtension(SubProgramFactory.SUBPROGRAM_CONTENT_TYPE);
+            String[] pathSegments = StringUtils.split(metadataPath, '/');
+            MetadataDefinition metadataDefinition = cType.getMetadataDefinition(pathSegments[0]);
+            
+            hasChanged = synchronizeMetadataForSharedProgram(doc, metadataDefinition, sharedProgramNode, sharedProgramDom, metadataPath, lang, report, logger) || hasChanged;
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize metadata for shared program
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgram the shared program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true is there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadataForSharedProgram(MetadataDefinition metadataDefinition, Node sharedProgramNode, SubProgram sharedProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (metadataDefinition.isMultiple())
+        {
+            return synchronizeMetadataMultipleForSharedProgram(metadataDefinition, sharedProgramNode, sharedProgram, metadataPath, report, logger);
+        }
+        else
+        {
+            return synchronizeMetadataSingleForSharedProgram(metadataDefinition, sharedProgramNode, sharedProgram, metadataPath, report, logger);
+        }
+    }
+    
+    /**
+     * Synchronize metadata for shared program
+     * @param doc the document
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgramDom the dom of the shared program
+     * @param metadataPath the metadata path
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return true is there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadataForSharedProgram(Document doc, MetadataDefinition metadataDefinition, Node sharedProgramNode, org.w3c.dom.Node sharedProgramDom, String metadataPath, String lang, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (metadataDefinition.isMultiple())
+        {
+            return synchronizeMetadataMultipleForSharedProgram(doc, metadataDefinition, sharedProgramNode, sharedProgramDom, metadataPath, lang, report, logger);
+        }
+        else
+        {
+            return synchronizeMetadataSingleForSharedProgram(doc, metadataDefinition, sharedProgramNode, sharedProgramDom, metadataPath, lang, report, logger);
+        }
+    }
+    
+    /**
+     * Synchronize multiple metadata for shared program
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgram the shared program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true is there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadataMultipleForSharedProgram(MetadataDefinition metadataDefinition, Node sharedProgramNode, SubProgram sharedProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        MetadataType type = metadataDefinition.getType();
+        Session session = sharedProgramNode.getSession();
+        ValueFactory valueFactory = session.getValueFactory();
+        switch (type)
+        {
+            case STRING:
+            case REFERENCE:
+            case USER:
+                Value[] stringValueArray = getStringArrayValue(metadataPath, sharedProgram, valueFactory, report, logger);
+                hasChanged = synchronizeArrayMetadata(sharedProgramNode, metadataPath, stringValueArray, report, logger);
+                break;
+            case DOUBLE:
+                Value[] doubleValueArray = getDoubleArrayValue(metadataPath, sharedProgram, valueFactory, report, logger);
+                hasChanged = synchronizeArrayMetadata(sharedProgramNode, metadataPath, doubleValueArray, report, logger);
+                break;
+            case LONG:
+                Value[] longValueArray = getLongArrayValue(metadataPath, sharedProgram, valueFactory, report, logger);
+                hasChanged = synchronizeArrayMetadata(sharedProgramNode, metadataPath, longValueArray, report, logger);
+                break;
+            default:
+                String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                break;
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize multiple metadata for shared program
+     * @param doc the document
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgramDom the dom of the shared program
+     * @param metadataPath the metadata path
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return true is there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadataMultipleForSharedProgram(Document doc, MetadataDefinition metadataDefinition, Node sharedProgramNode, org.w3c.dom.Node sharedProgramDom, String metadataPath, String lang, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        MetadataType type = metadataDefinition.getType();
+        Session session = sharedProgramNode.getSession();
+        ValueFactory valueFactory = session.getValueFactory();
+        switch (type)
+        {
+            case STRING:
+            case REFERENCE:
+            case USER:
+                Value[] stringValueArray = getStringArrayValue(doc, metadataPath, sharedProgramDom, valueFactory, lang, report, logger);
+                hasChanged = synchronizeArrayMetadata(sharedProgramNode, metadataPath, stringValueArray, report, logger);
+                break;
+            case DOUBLE:
+                Value[] doubleValueArray = getDoubleArrayValue(metadataPath, sharedProgramDom, valueFactory, report, logger);
+                hasChanged = synchronizeArrayMetadata(sharedProgramNode, metadataPath, doubleValueArray, report, logger);
+                break;
+            case LONG:
+                Value[] longValueArray = getLongArrayValue(metadataPath, sharedProgramDom, valueFactory, report, logger);
+                hasChanged = synchronizeArrayMetadata(sharedProgramNode, metadataPath, longValueArray, report, logger);
+                break;
+            default:
+                String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                break;
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize single metadata for shared program
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgram the shared program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true is there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadataSingleForSharedProgram(MetadataDefinition metadataDefinition, Node sharedProgramNode, SubProgram sharedProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        MetadataType type = metadataDefinition.getType();
+        Session session = sharedProgramNode.getSession();
+        ValueFactory valueFactory = session.getValueFactory();
+        switch (type)
+        {
+            case STRING:
+            case REFERENCE:
+            case USER:
+                Value stringValue = valueFactory.createValue(sharedProgram.getString(metadataPath));
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, stringValue, report, logger);
+                break;
+            case DOUBLE:
+                Value doubleValue = valueFactory.createValue(sharedProgram.getDouble(metadataPath));
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, doubleValue, report, logger);
+                break;
+            case LONG:
+                Value longValue = valueFactory.createValue(sharedProgram.getLong(metadataPath));
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, longValue, report, logger);
+                break;
+            case BOOLEAN:
+                Value booleanValue = valueFactory.createValue(sharedProgram.getBoolean(metadataPath));
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, booleanValue, report, logger);
+                break;
+            case COMPOSITE:
+                if (metadataDefinition instanceof RepeaterDefinition)
+                {
+                    hasChanged = synchronizeRepeaterMetadata(metadataDefinition, sharedProgramNode, sharedProgram, metadataPath, report, logger);
+                }
+                else
+                {    
+                    String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                    report.warn(warnMessage);
+                    logger.warn(warnMessage);
+                }
+                break;
+            default:
+                String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                break;
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize single metadata for shared program
+     * @param doc the document
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgramDom the dom of the shared program
+     * @param metadataPath the metadata path
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return true is there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadataSingleForSharedProgram(Document doc, MetadataDefinition metadataDefinition, Node sharedProgramNode, org.w3c.dom.Node sharedProgramDom, String metadataPath, String lang, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        MetadataType type = metadataDefinition.getType();
+        Session session = sharedProgramNode.getSession();
+        ValueFactory valueFactory = session.getValueFactory();
+        switch (type)
+        {
+            case STRING:
+            case REFERENCE:
+            case USER:
+                Value stringValue = valueFactory.createValue(_xPathProcessor.evaluateAsString(sharedProgramDom, metadataPath));
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, stringValue, report, logger);
+                break;
+            case DOUBLE:
+                Value doubleValue = valueFactory.createValue(_xPathProcessor.evaluateAsNumber(sharedProgramDom, metadataPath).doubleValue());
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, doubleValue, report, logger);
+                break;
+            case LONG:
+                Value longValue = valueFactory.createValue(_xPathProcessor.evaluateAsNumber(sharedProgramDom, metadataPath).longValue());
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, longValue, report, logger);
+                break;
+            case BOOLEAN:
+                Value booleanValue = valueFactory.createValue(_xPathProcessor.evaluateAsBoolean(sharedProgramDom, metadataPath));
+                hasChanged = synchronizeMetadata(sharedProgramNode, metadataPath, booleanValue, report, logger);
+                break;
+            case COMPOSITE:
+                if (metadataDefinition instanceof RepeaterDefinition)
+                {
+                    hasChanged = synchronizeRepeaterMetadata(doc, metadataDefinition, sharedProgramNode, sharedProgramDom, metadataPath, lang, report, logger);
+                }
+                else
+                {    
+                    String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                    report.warn(warnMessage);
+                    logger.warn(warnMessage);
+                }
+                break;
+            default:
+                String warnMessage = "La fusion des métadonnées n'est pas gérée pour le type '" + type.toString() + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                break;
+        }
+        
+        return hasChanged;
+    }
+    
+    /**
+     * Get string array value from the shared program
+     * @param metadataPath the metadata path
+     * @param sharedProgram the shared program
+     * @param valueFactory the value factory
+     * @param report the report logger
+     * @param logger the logger
+     * @return the string array
+     */
+    protected Value[] getStringArrayValue(String metadataPath, SubProgram sharedProgram, ValueFactory valueFactory, SynchronizationReport report, Logger logger)
+    {
+        String[] stringArray = sharedProgram.getStringArray(metadataPath);
+        Value[] stringValues = new Value[stringArray.length];
+        for (int i = 0; i < stringArray.length; i++)
+        {
+            stringValues[i] = valueFactory.createValue(stringArray[i]);
+        }
+        
+        return stringValues;
+    }
+    
+    /**
+     * Get string array value from the dom shared program
+     * @param doc the document
+     * @param metadataPath the metadata path
+     * @param sharedProgramDom the dom shared program
+     * @param valueFactory the value factory
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return the string array
+     */
+    protected Value[] getStringArrayValue(Document doc, String metadataPath, org.w3c.dom.Node sharedProgramDom, ValueFactory valueFactory, String lang, SynchronizationReport report, Logger logger)
+    {
+        List<String> listString = new ArrayList<String>();
+        org.w3c.dom.Node metadataNode = _xPathProcessor.selectSingleNode(sharedProgramDom, metadataPath);
+        String type = metadataNode.getAttributes().getNamedItem("type").getTextContent().trim();
+        
+        NodeList itemNodes = metadataNode.getChildNodes();
+        for (int j = 0; j < itemNodes.getLength(); j++)
+        {
+            // Specific for orgunit, need to get id from code (create it if no exist)
+            if (type.equals("orgunit"))
+            {
+                org.w3c.dom.Node itemNode = itemNodes.item(j);
+                OrgUnit ouContent = getOrCreateOrgUnitContent(doc, itemNode, lang, report, logger);
+                if (ouContent != null)
+                {
+                    listString.add(ouContent.getId());
+                }
+            }
+            else if (type.equals("person")) // Specific for person, need to get id from code (create it if no exist)
+            {
+                org.w3c.dom.Node itemNode = itemNodes.item(j);
+                Person personContent = getOrCreatePersonContent(doc, itemNode, lang, report, logger);
+                if (personContent != null)
+                {
+                    listString.add(personContent.getId());
+                }
+            }
+            else
+            {
+                String stringValue = itemNodes.item(j).getTextContent().trim();
+                if (StringUtils.isNotBlank(stringValue))
+                {
+                    listString.add(stringValue);
+                }
+            }
+        }
+        
+        Value[] stringValues = new Value[listString.size()];
+        for (int i = 0; i < listString.size(); i++)
+        {
+            stringValues[i] = valueFactory.createValue(listString.get(i));
+        }
+        
+        return stringValues;
+    }
+    
+    /** 
+     * Get or create orgUnit content
+     * @param doc the document
+     * @param itemNode the item node
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return the orgUnit
+     */
+    protected OrgUnit getOrCreateOrgUnitContent(Document doc, org.w3c.dom.Node itemNode, String lang, SynchronizationReport report, Logger logger)
+    {
+        boolean ouImportMode = false;
+        String cdmCode = itemNode.getTextContent().trim();
+        org.w3c.dom.Node ouNode = _xPathProcessor.selectSingleNode(doc.getFirstChild(), "orgunit[@CDMid ='" + cdmCode + "']");
+        OrgUnit ouContent = _importManager.getLocalOrgUnitIfExists(ouNode, null, report, logger);
+        if (ouContent == null)
+        {
+            ouContent = _importManager.createOrgUnit(ouNode, null, report, logger); // default language
+            ouImportMode = true;
+        }
+        
+        if (ouContent != null)
+        {
+            try
+            {
+                if (!_importManager._synchronizedContents.contains(ouContent.getId()))
+                {
+                    // Synchronize OrgUnit
+                    String infoMsg = "Synchronisation de la composante \"" + ouContent.getTitle() + " (" + ouContent.getUAICode() + ")\"";
+                    report.info(infoMsg);
+                    logger.info(infoMsg);
+                    
+                    if (_importManager.synchronizeContent(doc, ouContent, ouNode, report, logger, ouImportMode, lang))
+                    {
+                        _importManager.applyChanges(ouContent, report, logger);
+                    }
+                    else
+                    {
+                        infoMsg = "Aucune modification détectée sur la composante \"" + ouContent.getTitle() + "\" depuis la dernière synchronisation";
+                        report.info(infoMsg);
+                        logger.info(infoMsg);
+                    }
+                }
+            }
+            catch (Exception e)
+            {
+                String errorMsg = "Une erreur est survenue lors la synchronization de l'établissement '" + ouContent.getTitle() + "'";
+                report.info(errorMsg);
+                logger.info(errorMsg);
+            }
+            
+            if (ouImportMode)
+            {
+                // Direct validation if permitted
+                _importManager.validateContent(ouContent, report, logger);
+            }
+        }
+        
+        return ouContent;
+    }
+    
+    /** 
+     * Get or create person content
+     * @param doc the document
+     * @param itemNode the item node
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return the person
+     */
+    protected Person getOrCreatePersonContent(Document doc, org.w3c.dom.Node itemNode, String lang, SynchronizationReport report, Logger logger)
+    {
+        boolean personImportMode = false;
+        String cdmCode = itemNode.getTextContent().trim();
+        org.w3c.dom.Node personNode = _xPathProcessor.selectSingleNode(doc.getFirstChild(), "person[@CDMid ='" + cdmCode + "']");
+        Person personContent = _importManager.getLocalPersonIfExists(personNode, null, report, logger);
+        if (personContent == null)
+        {
+            personContent = _importManager.createPerson(personNode, null, report, logger); // default language
+            personImportMode = true;
+        }
+        
+        if (personContent != null)
+        {
+            try
+            {
+                if (!_importManager._synchronizedContents.contains(personContent.getId()))
+                {
+                    // Synchronize person
+                    String infoMsg = "Synchronisation de la personne \"" + personContent.getName() + "\"";
+                    report.info(infoMsg);
+                    logger.info(infoMsg);
+                    
+                    if (_importManager.synchronizeContent(doc, personContent, personNode, report, logger, personImportMode, lang))
+                    {
+                        _importManager.applyChanges(personContent, report, logger);
+                    }
+                    else
+                    {
+                        infoMsg = "Aucune modification détectée sur la personne \"" + personContent.getName() + "\" depuis la dernière synchronisation";
+                        report.info(infoMsg);
+                        logger.info(infoMsg);
+                    }
+                }
+            }
+            catch (Exception e)
+            {
+                String errorMsg = "Une erreur est survenue lors la synchronization de la person '" + personContent.getTitle() + "'";
+                report.info(errorMsg);
+                logger.info(errorMsg);
+            }
+            
+            if (personImportMode)
+            {
+                // Direct validation if permitted
+                _importManager.validateContent(personContent, report, logger);
+            }
+        }
+        
+        return personContent;
+    }
+    
+    /**
+     * Get long array value from the shared program
+     * @param metadataPath the metadata path
+     * @param sharedProgram the shared program
+     * @param valueFactory the value factory
+     * @param report the report logger
+     * @param logger the logger
+     * @return the long array
+     */
+    protected Value[] getLongArrayValue(String metadataPath, SubProgram sharedProgram, ValueFactory valueFactory, SynchronizationReport report, Logger logger)
+    {
+        long[] longArray = sharedProgram.getLongArray(metadataPath);
+        Value[] longValues = new Value[longArray.length];
+        for (int i = 0; i < longArray.length; i++)
+        {
+            longValues[i] = valueFactory.createValue(longArray[i]);
+        }
+        
+        return longValues;
+    }
+    
+    /**
+     * Get long array value from the dom shared program
+     * @param metadataPath the metadata path
+     * @param sharedProgramDom the dom shared program
+     * @param valueFactory the value factory
+     * @param report the report logger
+     * @param logger the logger
+     * @return the long array
+     */
+    protected Value[] getLongArrayValue(String metadataPath, org.w3c.dom.Node sharedProgramDom, ValueFactory valueFactory, SynchronizationReport report, Logger logger)
+    {
+        List<Long> listLong = new ArrayList<Long>();
+        org.w3c.dom.Node metadataNode = _xPathProcessor.selectSingleNode(sharedProgramDom, metadataPath);
+        
+        NodeList itemNodes = metadataNode.getChildNodes();
+        for (int j = 0; j < itemNodes.getLength(); j++)
+        {
+            String longValueAsString = itemNodes.item(j).getTextContent().trim();
+            if (StringUtils.isNotBlank(longValueAsString))
+            {
+                listLong.add(Long.valueOf(longValueAsString));
+            }
+        }
+        
+        Value[] longValues = new Value[listLong.size()];
+        for (int i = 0; i < listLong.size(); i++)
+        {
+            longValues[i] = valueFactory.createValue(listLong.get(i));
+        }
+        
+        return longValues;
+    }
+    
+    /**
+     * Get double array value from the shared program
+     * @param metadataPath the metadata path
+     * @param sharedProgram the shared program
+     * @param valueFactory the value factory
+     * @param report the report logger
+     * @param logger the logger
+     * @return the double array
+     */
+    protected Value[] getDoubleArrayValue(String metadataPath, SubProgram sharedProgram, ValueFactory valueFactory, SynchronizationReport report, Logger logger)
+    {
+        double[] doubleArray = sharedProgram.getDoubleArray(metadataPath);
+        Value[] doubleValues = new Value[doubleArray.length];
+        for (int i = 0; i < doubleArray.length; i++)
+        {
+            doubleValues[i] = valueFactory.createValue(doubleArray[i]);
+        }
+        
+        return doubleValues;
+    }
+    
+    /**
+     * Get double array value from the dom shared program
+     * @param metadataPath the metadata path
+     * @param sharedProgramDom the dom shared program
+     * @param valueFactory the value factory
+     * @param report the report logger
+     * @param logger the logger
+     * @return the double array
+     */
+    protected Value[] getDoubleArrayValue(String metadataPath, org.w3c.dom.Node sharedProgramDom, ValueFactory valueFactory, SynchronizationReport report, Logger logger)
+    {
+        List<Double> listDouble = new ArrayList<Double>();
+        org.w3c.dom.Node metadataNode = _xPathProcessor.selectSingleNode(sharedProgramDom, metadataPath);
+        
+        NodeList itemNodes = metadataNode.getChildNodes();
+        for (int j = 0; j < itemNodes.getLength(); j++)
+        {
+            String doubleValueAsString = itemNodes.item(j).getTextContent().trim();
+            if (StringUtils.isNotBlank(doubleValueAsString))
+            {
+                listDouble.add(Double.valueOf(doubleValueAsString));
+            }
+        }
+        
+        Value[] doubleValues = new Value[listDouble.size()];
+        for (int i = 0; i < listDouble.size(); i++)
+        {
+            doubleValues[i] = valueFactory.createValue(listDouble.get(i));
+        }
+        
+        return doubleValues;
+    }
+    
+    /**
+     * Synchronize array metadata
+     * @param sharedProgramNode the shared program node
+     * @param metadataPath the metadata path
+     * @param valueArray the array of value
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeArrayMetadata(Node sharedProgramNode, String metadataPath, Value[] valueArray, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        boolean hasChanged = false;
+        if (sharedProgramNode.hasProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath))
+        {
+            Property property = sharedProgramNode.getProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath);
+            if (!ArrayUtils.isEquals(valueArray, property.getValues()))
+            {
+                sharedProgramNode.setProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, valueArray);
+                hasChanged = true;
+            }
+        }
+        else
+        {
+            sharedProgramNode.setProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, valueArray);
+            hasChanged = true;
+        }
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize metadata
+     * @param sharedProgramNode the shared program node
+     * @param fullMetadataPath the metadata path
+     * @param value the array of value
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some change
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeMetadata(Node sharedProgramNode, String fullMetadataPath, Value value, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        String metadataPath = fullMetadataPath;
+        if (StringUtils.contains(fullMetadataPath, "/"))
+        {
+            metadataPath = StringUtils.substringAfterLast(fullMetadataPath, "/");
+        }
+        
+        boolean hasChanged = false;
+        if (sharedProgramNode.hasProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath))
+        {
+            Property property = sharedProgramNode.getProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath);
+            if (!value.equals(property.getValue()))
+            {
+                sharedProgramNode.setProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, value);
+                hasChanged = true;
+            }
+        }
+        else
+        {
+            sharedProgramNode.setProperty(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, value);
+            hasChanged = true;
+        }
+        return hasChanged;
+    }
+    
+    /**
+     * Synchronize repeater metadata for shared program
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgram the shared program
+     * @param metadataPath the metadata path
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some changed (always true for repeater)
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeRepeaterMetadata(MetadataDefinition metadataDefinition, Node sharedProgramNode, SubProgram sharedProgram, String metadataPath, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (sharedProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath))
+        {
+            sharedProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath).remove();
+        }
+        
+        Node repeaterNode = sharedProgramNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, "ametys:compositeMetadata");
+        
+        ModifiableCompositeMetadata metadataHolder = sharedProgram.getMetadataHolder();
+        if (metadataHolder.hasMetadata(metadataPath))
+        {
+            ModifiableCompositeMetadata compositeMetadata = metadataHolder.getCompositeMetadata(metadataPath);
+            for (String name : compositeMetadata.getMetadataNames())
+            {
+                Node repeaterEntryNode = repeaterNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + name, "ametys:compositeMetadata");
+                CompositeMetadata metadataRepeater = compositeMetadata.getCompositeMetadata(name);
+                
+                for (String metadataRepeaterPath : metadataRepeater.getMetadataNames())
+                {
+                    String fullMetadataPath = metadataPath + "/" + name + "/" + metadataRepeaterPath;
+                    
+                    MetadataDefinition metadataRepeaterDefinition = metadataDefinition.getMetadataDefinition(metadataRepeaterPath);
+                    synchronizeMetadataForSharedProgram(metadataRepeaterDefinition, repeaterEntryNode, sharedProgram, fullMetadataPath, report, logger);
+                }                            
+            }
+        }
+        
+        return true;
+    }
+    
+    /**
+     * Synchronize repeater metadata for shared program
+     * @param doc the document
+     * @param metadataDefinition the metadata definition
+     * @param sharedProgramNode the jcr node of the shared program
+     * @param sharedProgramDom the dom of the shared program
+     * @param metadataPath the metadata path
+     * @param lang the lang
+     * @param report the report logger
+     * @param logger the logger
+     * @return true if there are some changed (always true for repeater)
+     * @throws RepositoryException if an error occurred
+     */
+    protected boolean synchronizeRepeaterMetadata(Document doc, MetadataDefinition metadataDefinition, Node sharedProgramNode, org.w3c.dom.Node sharedProgramDom, String metadataPath, String lang, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        if (sharedProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath))
+        {
+            sharedProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath).remove();
+        }
+        
+        Node repeaterNode = sharedProgramNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + metadataPath, "ametys:compositeMetadata");
+        
+        org.w3c.dom.Node repeaterDom = _xPathProcessor.selectSingleNode(sharedProgramDom, metadataPath);
+        NodeList entryNodes = repeaterDom.getChildNodes();
+        
+        for (int i = 0; i < entryNodes.getLength(); i++)
+        {
+            org.w3c.dom.Node entryNode = entryNodes.item(i);
+            String entryName = entryNode.getAttributes().getNamedItem("name").getTextContent().trim();
+            
+            Node repeaterEntryNode = repeaterNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + entryName, "ametys:compositeMetadata");
+            
+            NodeList childNodes = entryNode.getChildNodes();
+            for (int j = 0; j < childNodes.getLength(); j++)
+            {
+                org.w3c.dom.Node childNode = childNodes.item(j);
+                String subMetadataName = childNode.getLocalName();
+                MetadataDefinition metadataRepeaterDefinition = metadataDefinition.getMetadataDefinition(subMetadataName);
+                
+                synchronizeMetadataForSharedProgram(doc, metadataRepeaterDefinition, repeaterEntryNode, entryNode, subMetadataName, lang, report, logger);
+            }
+        }
+        
+        return true;
+    }
+    
+    /**
+     * Get the shared program node (create it if no exist)
+     * @param mainProgram the main program
+     * @param subProgramCode the sub program code
+     * @param report the report logger
+     * @param logger the logger
+     * @return the shared program node
+     * @throws RepositoryException if an error occurred
+     */
+    protected Node getSharedProgramNode(SubProgram mainProgram, String subProgramCode, SynchronizationReport report, Logger logger) throws RepositoryException
+    {
+        Node mainProgramNode = mainProgram.getNode();
+        Node rootNode = null;
+        if (mainProgramNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE))
+        {
+            rootNode = mainProgramNode.getNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE);
+        }
+        else
+        {
+            rootNode = mainProgramNode.addNode(RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":" + SHARED_PROGRAMS_JCR_NODE, "ametys:compositeMetadata");
+        }
+        
+        if (rootNode.hasNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + subProgramCode))
+        {
+            return rootNode.getNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + subProgramCode);
+        }
+        else
+        {
+            return rootNode.addNode(RepositoryConstants.NAMESPACE_PREFIX + ":" + subProgramCode, "ametys:compositeMetadata");
+        }
+    }
+    
+    private boolean _checkMetadataPath(Set<String> metadataToMerge, SynchronizationReport report, Logger logger)
+    {
+        ContentType subProgramContentType = _cTypeE.getExtension(SubProgramFactory.SUBPROGRAM_CONTENT_TYPE);
+        for (String metadataPath : metadataToMerge)
+        {
+            if (StringUtils.contains(metadataPath, "/"))
+            {
+                String warnMessage = "Les metadonnées de type composite ne sont pas gérées : '" + metadataPath + "'";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                
+                return false;
+            }
+            
+            if (subProgramContentType.getMetadataDefinition(metadataPath) == null)
+            {
+                String warnMessage = "La metadonnée '" + metadataPath + "' est invalide pour un sous-programme";
+                report.warn(warnMessage);
+                logger.warn(warnMessage);
+                
+                return false;
+            }
+        }
+        
+        return true;
+    }
+}
